﻿@using SPAWebApp.Shared
@using SPAWebApp.Shared.Models
@using SPAWebApp.Client.Services.Contracts
@using SPAWebApp.Shared.Models.Services.ConstructDocument
@using SPAWebApp.Shared.Models.ViewModels
@using SPAWebApp.Shared.Models.ViewModels.ConstructDocument
@inject IConstructDocumentService ConstructDocumentService

@if (ModifyDocumentViewModel == null)
{
  <p>Wait, please...</p>
}
else
{
  <EditForm Model="@ModifyDocumentViewModel" OnValidSubmit="@(async () => await ChangeDocumentAsync())">
    <div class="form-group row">
      <label for="staticEmail" class="col-sm-2 col-form-label">id</label>
      <div class="col-sm-10">
        <p>@Document.Id</p>
      </div>
    </div>
    <div class="form-group row">
      <label for="inputPassword" class="col-sm-2 col-form-label">Designation</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="Designation" value="@ModifyDocumentViewModel.NewDesignation" bind="@ModifyDocumentViewModel.NewDesignation" />
      </div>
    </div>
    <div class="form-group row">
      <label for="inputPassword" class="col-sm-2 col-form-label">Version</label>
      <div class="col-sm-10">
        <p>@Document.Revision</p>
      </div>
    </div>
    <div class="form-group row">
      <label for="inputPassword" class="col-sm-2 col-form-label">State</label>
      <div class="col-sm-10">
        <p>@Document.State</p>
      </div>
    </div>
    <div class="form-group row">
      <label for="inputPassword" class="col-sm-2 col-form-label">Name</label>
      <div class="col-sm-10">
        <input type="text" class="form-control" placeholder="Name" value="@ModifyDocumentViewModel.NewName" bind="@ModifyDocumentViewModel.NewName" />
      </div>
    </div>
    <button class="btn btn-info" title="OK" type="submit"><i class="fas fa-check-square"></i></button>
  </EditForm>
}
@functions {
  [Parameter]
  protected Document Document { get; set; }

  [Parameter]
  protected Action DocumentChanged { get; set; }

  protected ModifyDocumentVM ModifyDocumentViewModel { get; set; }
  private bool changeState = false;

  protected override void OnInit()
  {
    ModifyDocumentViewModel = new ModifyDocumentVM(Document);
  }

  private async Task ChangeDocumentAsync()
  {
    await ConstructDocumentService.ChangeDocumentAsync(ModifyDocumentViewModel);
    //if (!result.Succeed)
    //{
    //  Console.WriteLine(result.Message);
    //}
    StateHasChanged();
  }

}